# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Dict, List, Mapping, Optional, Tuple, Union
from . import _utilities, _tables
from . import outputs
from ._inputs import *

__all__ = ['DashboardList']


class DashboardList(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dash_items: Optional[pulumi.Input[List[pulumi.Input[pulumi.InputType['DashboardListDashItemArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Provides a Datadog dashboard_list resource. This can be used to create and manage Datadog Dashboard Lists and the individual dashboards within them.

        ## Example Usage

        Create a new Dashboard list with two dashboards

        ```python
        import pulumi
        import pulumi_datadog as datadog

        time = datadog.Dashboard("time",
            description="Created using the Datadog provider in TF",
            is_read_only=True,
            layout_type="ordered",
            title="TF Test Layout Dashboard",
            widgets=[datadog.DashboardWidgetArgs(
                alert_graph_definition=datadog.DashboardWidgetAlertGraphDefinitionArgs(
                    alert_id="1234",
                    time=datadog.DashboardWidgetAlertGraphDefinitionTimeArgs(
                        live_span="1h",
                    ),
                    title="Widget Title",
                    viz_type="timeseries",
                ),
            )])
        screen = datadog.Dashboard("screen",
            description="Created using the Datadog provider in TF",
            is_read_only=False,
            layout_type="free",
            title="TF Test Free Layout Dashboard",
            widgets=[datadog.DashboardWidgetArgs(
                event_stream_definition=datadog.DashboardWidgetEventStreamDefinitionArgs(
                    event_size="l",
                    query="*",
                    time=datadog.DashboardWidgetEventStreamDefinitionTimeArgs(
                        live_span="1h",
                    ),
                    title="Widget Title",
                    title_align="left",
                    title_size="16",
                ),
                layout=datadog.DashboardWidgetLayoutArgs(
                    height=43,
                    width=32,
                    x=5,
                    y=5,
                ),
            )])
        new_list = datadog.DashboardList("newList",
            dash_items=[
                datadog.DashboardListDashItemArgs(
                    dash_id=time.id,
                    type="custom_timeboard",
                ),
                datadog.DashboardListDashItemArgs(
                    dash_id=screen.id,
                    type="custom_screenboard",
                ),
            ],
            name="TF Created List",
            opts=ResourceOptions(depends_on=[
                    "datadog_dashboard.screen",
                    "datadog_dashboard.time",
                ]))
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[List[pulumi.Input[pulumi.InputType['DashboardListDashItemArgs']]]] dash_items: A set of dashbaord items that belong to this list
        :param pulumi.Input[str] name: The name of the Dashboard List
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['dash_items'] = dash_items
            if name is None:
                raise TypeError("Missing required property 'name'")
            __props__['name'] = name
        super(DashboardList, __self__).__init__(
            'datadog:index/dashboardList:DashboardList',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            dash_items: Optional[pulumi.Input[List[pulumi.Input[pulumi.InputType['DashboardListDashItemArgs']]]]] = None,
            name: Optional[pulumi.Input[str]] = None) -> 'DashboardList':
        """
        Get an existing DashboardList resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[List[pulumi.Input[pulumi.InputType['DashboardListDashItemArgs']]]] dash_items: A set of dashbaord items that belong to this list
        :param pulumi.Input[str] name: The name of the Dashboard List
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["dash_items"] = dash_items
        __props__["name"] = name
        return DashboardList(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="dashItems")
    def dash_items(self) -> pulumi.Output[Optional[List['outputs.DashboardListDashItem']]]:
        """
        A set of dashbaord items that belong to this list
        """
        return pulumi.get(self, "dash_items")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the Dashboard List
        """
        return pulumi.get(self, "name")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

