# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Dict, List, Mapping, Optional, Tuple, Union
from . import _utilities, _tables
from . import outputs
from ._inputs import *

__all__ = ['SyntheticsTest']


class SyntheticsTest(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 assertions: Optional[pulumi.Input[List[pulumi.Input[Mapping[str, Any]]]]] = None,
                 device_ids: Optional[pulumi.Input[List[pulumi.Input[str]]]] = None,
                 locations: Optional[pulumi.Input[List[pulumi.Input[str]]]] = None,
                 message: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 options: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestOptionsArgs']]] = None,
                 options_list: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestOptionsListArgs']]] = None,
                 request: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestRequestArgs']]] = None,
                 request_basicauth: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestRequestBasicauthArgs']]] = None,
                 request_headers: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 request_query: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 steps: Optional[pulumi.Input[List[pulumi.Input[pulumi.InputType['SyntheticsTestStepArgs']]]]] = None,
                 subtype: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[List[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Create a SyntheticsTest resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if assertions is not None:
                warnings.warn("Use assertion instead", DeprecationWarning)
                pulumi.log.warn("assertions is deprecated: Use assertion instead")
            __props__['assertions'] = assertions
            __props__['device_ids'] = device_ids
            if locations is None:
                raise TypeError("Missing required property 'locations'")
            __props__['locations'] = locations
            __props__['message'] = message
            if name is None:
                raise TypeError("Missing required property 'name'")
            __props__['name'] = name
            if options is not None:
                warnings.warn("This parameter is deprecated, please use `options_list`", DeprecationWarning)
                pulumi.log.warn("options is deprecated: This parameter is deprecated, please use `options_list`")
            __props__['options'] = options
            __props__['options_list'] = options_list
            if request is None:
                raise TypeError("Missing required property 'request'")
            __props__['request'] = request
            __props__['request_basicauth'] = request_basicauth
            __props__['request_headers'] = request_headers
            __props__['request_query'] = request_query
            if status is None:
                raise TypeError("Missing required property 'status'")
            __props__['status'] = status
            __props__['steps'] = steps
            __props__['subtype'] = subtype
            if tags is None:
                raise TypeError("Missing required property 'tags'")
            __props__['tags'] = tags
            if type is None:
                raise TypeError("Missing required property 'type'")
            __props__['type'] = type
            __props__['monitor_id'] = None
        super(SyntheticsTest, __self__).__init__(
            'datadog:index/syntheticsTest:SyntheticsTest',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            assertions: Optional[pulumi.Input[List[pulumi.Input[Mapping[str, Any]]]]] = None,
            device_ids: Optional[pulumi.Input[List[pulumi.Input[str]]]] = None,
            locations: Optional[pulumi.Input[List[pulumi.Input[str]]]] = None,
            message: Optional[pulumi.Input[str]] = None,
            monitor_id: Optional[pulumi.Input[float]] = None,
            name: Optional[pulumi.Input[str]] = None,
            options: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestOptionsArgs']]] = None,
            options_list: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestOptionsListArgs']]] = None,
            request: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestRequestArgs']]] = None,
            request_basicauth: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestRequestBasicauthArgs']]] = None,
            request_headers: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            request_query: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            status: Optional[pulumi.Input[str]] = None,
            steps: Optional[pulumi.Input[List[pulumi.Input[pulumi.InputType['SyntheticsTestStepArgs']]]]] = None,
            subtype: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[List[pulumi.Input[str]]]] = None,
            type: Optional[pulumi.Input[str]] = None) -> 'SyntheticsTest':
        """
        Get an existing SyntheticsTest resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["assertions"] = assertions
        __props__["device_ids"] = device_ids
        __props__["locations"] = locations
        __props__["message"] = message
        __props__["monitor_id"] = monitor_id
        __props__["name"] = name
        __props__["options"] = options
        __props__["options_list"] = options_list
        __props__["request"] = request
        __props__["request_basicauth"] = request_basicauth
        __props__["request_headers"] = request_headers
        __props__["request_query"] = request_query
        __props__["status"] = status
        __props__["steps"] = steps
        __props__["subtype"] = subtype
        __props__["tags"] = tags
        __props__["type"] = type
        return SyntheticsTest(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def assertions(self) -> pulumi.Output[Optional[List[Mapping[str, Any]]]]:
        return pulumi.get(self, "assertions")

    @property
    @pulumi.getter(name="deviceIds")
    def device_ids(self) -> pulumi.Output[Optional[List[str]]]:
        return pulumi.get(self, "device_ids")

    @property
    @pulumi.getter
    def locations(self) -> pulumi.Output[List[str]]:
        return pulumi.get(self, "locations")

    @property
    @pulumi.getter
    def message(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "message")

    @property
    @pulumi.getter(name="monitorId")
    def monitor_id(self) -> pulumi.Output[float]:
        return pulumi.get(self, "monitor_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def options(self) -> pulumi.Output[Optional['outputs.SyntheticsTestOptions']]:
        return pulumi.get(self, "options")

    @property
    @pulumi.getter(name="optionsList")
    def options_list(self) -> pulumi.Output[Optional['outputs.SyntheticsTestOptionsList']]:
        return pulumi.get(self, "options_list")

    @property
    @pulumi.getter
    def request(self) -> pulumi.Output['outputs.SyntheticsTestRequest']:
        return pulumi.get(self, "request")

    @property
    @pulumi.getter(name="requestBasicauth")
    def request_basicauth(self) -> pulumi.Output[Optional['outputs.SyntheticsTestRequestBasicauth']]:
        return pulumi.get(self, "request_basicauth")

    @property
    @pulumi.getter(name="requestHeaders")
    def request_headers(self) -> pulumi.Output[Optional[Mapping[str, Any]]]:
        return pulumi.get(self, "request_headers")

    @property
    @pulumi.getter(name="requestQuery")
    def request_query(self) -> pulumi.Output[Optional[Mapping[str, Any]]]:
        return pulumi.get(self, "request_query")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def steps(self) -> pulumi.Output[Optional[List['outputs.SyntheticsTestStep']]]:
        return pulumi.get(self, "steps")

    @property
    @pulumi.getter
    def subtype(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "subtype")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[List[str]]:
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        return pulumi.get(self, "type")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

